<script setup lang="ts">
import { number_or_string_to_int, params_to_string } from "@/functions";
import { computed, reactive, watch } from "vue";

const state = reactive<{
  // loading: boolean;
  activity_threshold: number;
  edge_threshold: number;
  svg_url: string | null;
}>({
  // loading: false,
  activity_threshold: 500,
  edge_threshold: 500,
  svg_url: null,
});

interface Props {
  api_route: string | null;
}
const props = defineProps<Props>();

function get_svg_url(
  api_cluster_route: string,
  edge_threshold: number,
  activity_threshold: number
) {
  return `${api_cluster_route}?${params_to_string({
    edge_threshold: String(edge_threshold),
    activity_threshold: String(activity_threshold),
  })}`;
}

function updateSVGURL() {
  if (props.api_route != null)
    state.svg_url = get_svg_url(
      props.api_route,
      state.activity_threshold,
      state.edge_threshold
    );
}

if (props.api_route != null)
  state.svg_url = get_svg_url(
    props.api_route,
    state.edge_threshold,
    state.activity_threshold,
  );

watch(
  () => props.api_route,
  (new_val: string | null) => {
    if (new_val != null)
      state.svg_url = get_svg_url(
        new_val,
        state.activity_threshold,
        state.edge_threshold
      );
  }
);

const c_activity_threshold = computed({
  get() {
    return state.activity_threshold;
  },
  set(val: number | string) {
    state.activity_threshold = number_or_string_to_int(val);
  },
});

const c_edge_threshold = computed({
  get() {
    return state.edge_threshold;
  },
  set(val: number | string) {
    state.edge_threshold = number_or_string_to_int(val);
  },
});

/*
watch(
  () => state.activity_threshold,
  (new_val: number) => {
    if (new_val != null && props.api_route != null)
      state.svg_url = get_svg_url(
        props.api_route,
        new_val,
        state.edge_threshold
      );
  }
);

watch(
  () => state.edge_threshold,
  (new_val: number) => {
    if (new_val != null && props.api_route != null)
      state.svg_url = get_svg_url(
        props.api_route,
        state.activity_threshold,
        new_val
      );
  }
);
*/
</script>
<template>
  <div class="row mb-3 pb-3" @keyup.enter="updateSVGURL">
    <h4 class="text-light">Visualization:</h4>
    <div v-if="props.api_route == null" class="col-12">No file selected!</div>
    <template v-else-if="state.svg_url != null">
      <div class="col-10 ocel-img-wrapper">
        <img :src="state.svg_url" />
      </div>
      <div class="col-2">
        <div class="form-floating mb-2">
          <input
            type="number"
            class="form-control"
            id="edge-threshold-input"
            aria-label="edge-threshold-input"
            :disabled="state.svg_url == null"
            v-model="c_edge_threshold"
          />
          <label for="edge-threshold-input">edge-treshold</label>
        </div>
        <div class="form-floating mb-2">
          <input
            type="number"
            class="form-control"
            id="activity-threshold-input"
            aria-label="activity-threshold-input"
            :disabled="state.svg_url == null"
            v-model="c_activity_threshold"
          />
          <label for="activity-threshold-input">activity-treshold</label>
        </div>
        <button class="btn btn-primary" @click="updateSVGURL">Refresh</button>
      </div>
    </template>
  </div>
</template>

<style scoped>
.ocel-img-wrapper {
  max-height: 300px;
  overflow: scroll;
  padding: 20px;
}
</style>
